var lWarn = {logln:function (o){}};
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "auto-off.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

function storeSubParameter(path, value) {
    Property.setProperty('settings/' + path, value);
    Property.setFlag('settings/' + path, 'ARCHIVE', true);
}

function setTrigger(parameters) 
{
    var zoneID = parseInt(parameters.ZoneID, 10);
    var offDelay = parseInt(parameters.offDelay, 10);
    var groupID=1;
    var sceneID=5;
    if (isNaN(zoneID))
    { 
        lWarn.logln("Set trigger: invalid zoneID parameter " + parameters.zoneID);
        return;
    }

    if (isNaN(offDelay)) 
    {
        lWarn.logln("Set trigger: invalid offDelay parameter " + 
                parameters.offDelay);
        return;
    }
    
    var baseNode = Property.getNode('settings');
    if (baseNode != null) {
        baseNode.removeChild(zoneID);
    }

    
    if (offDelay==0)
    {
        lWarn.logln("Reset Auto off for Zone " + zoneID);
        unregisterTrigger(baseNode.getPath() + "/" + zoneID);
        Property.store();
        return;
    }
        
    storeSubParameter(zoneID + '/ZoneID', zoneID);
    storeSubParameter(zoneID + '/offDelay', offDelay);
    
    storeSubParameter(zoneID + '/delay', offDelay*60);
    
    var sTriggerSubpath=zoneID + '/triggers/0/';
    storeSubParameter(sTriggerSubpath + "type" , 'zone-scene');
    storeSubParameter(sTriggerSubpath + "zone" , zoneID);
    storeSubParameter(sTriggerSubpath + "group" , groupID);
    storeSubParameter(sTriggerSubpath + "scene" , sceneID);
    storeSubParameter(sTriggerSubpath + "dsid" , -1);
    
    
    var sActionPath=zoneID + '/actions/0/';
    storeSubParameter(sActionPath + 'type', 'zone-scene');
    storeSubParameter(sActionPath + 'zone', zoneID);
    storeSubParameter(sActionPath + 'group', groupID);
    storeSubParameter(sActionPath + 'scene', 0);
    storeSubParameter(sActionPath + 'force', true);
    storeSubParameter(sActionPath + 'category', 'timer');
    
    var sConditionPath=zoneID + '/conditions/zone-states/0/';
    storeSubParameter(sConditionPath + 'zone', zoneID);
    storeSubParameter(sConditionPath + 'group', groupID);
    storeSubParameter(sConditionPath + 'scene', sceneID);
    
    Property.store();
    updateTriggerRegistration(Property.getNode('settings/' + zoneID));
}

function updateAllTrigger()
{
    var baseNode = Property.getNode('settings');
    if (baseNode == null) {
        lInfo.logln("Auto-off update all trigger : no entries");
        return;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        lInfo.logln("Auto-off Set Trigger" + iIndex);
        var oChildNode = oArrayNode[iIndex];
        updateTriggerRegistration(oChildNode);
    }
}

function updateTriggerRegistration(oChildNode)
{
    var oParameter={};     
    registerTrigger(oChildNode.getPath(),'auto-off_start',oParameter);
}

function startWaiting() {
	var sID=""+Math.random();
	
    lInfo.logln("Autooff action has been started, using ID " + sID);
    var iDelay=0;
    var iDelayNode=Property.getNode(raisedEvent.parameter.path + "/delay");
    if (iDelayNode!=null) 
        iDelay=iDelayNode.getValue();
    
    Property.setProperty(raisedEvent.parameter.path + "/sID", sID);
    Property.setFlag(raisedEvent.parameter.path + "/sID", 'ARCHIVE', true);

    
    (new Event('auto-off_end',{path:raisedEvent.parameter.path,sID:sID, time : '+' + iDelay})).raise();
    Property.store();
}

function executeAction() {
	var sID='';
    var sIDNode=Property.getNode(raisedEvent.parameter.path + "/sID");
    if (sIDNode!=null) {
    	sID=sIDNode.getValue();
    	lInfo.logln('Action ID is ' + raisedEvent.parameter.sID + ", property ID is " + sID);
    	if (sID!=raisedEvent.parameter.sID) {
    		lInfo.logln('Action must be prolonged, this action is to early');
    		return;
    	}
    	lInfo.logln('Execute Action now ' + raisedEvent.parameter.path);
        (new Event('action_execute',{path:raisedEvent.parameter.path})).raise();
        Property.getNode(raisedEvent.parameter.path).removeChild("sID");
        Property.store();
    } else {
		lInfo.logln('No ID Node');
		return;    	
    }
}

function upgradeValues() {
    var baseNode = Property.getNode('settings');
    if (baseNode == null) {
        lInfo.logln("Auto-off update all trigger : no entries");
        return;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        lInfo.logln("check Trigger " + iIndex);       
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('triggers')==null)
        	if (oChildNode.getChild('ZoneID')!=null)
        		if (oChildNode.getChild('offDelay')!=null){
		        	lInfo.logln('Upgrade trigger ' + iIndex);
		        	setTrigger({ZoneID:''+oChildNode.getChild('ZoneID').getValue(),offDelay:''+oChildNode.getChild('offDelay').getValue()});
		        }
        if (oChildNode.getChild('ZoneID')!=null) {
        	lInfo.logln("Debugoutput " + oChildNode.getChild('ZoneID'));
        }
    }
}

lInfo.logln(raisedEvent.name);

if (raisedEvent.name == 'running')
{
	lInfo.logln("auto-off running");
    Property.load();
    upgradeValues();
    updateAllTrigger();
}
else if (raisedEvent.name == 'auto-off_set') 
{
	Property.load();
    setTrigger(raisedEvent.parameter);
}
else if (raisedEvent.name == 'auto-off_start') 
{
	Property.load();
	startWaiting();
}
else if (raisedEvent.name == 'auto-off_end') 
{
	Property.load();
	executeAction();
}